SystemOrganization addCategory: #'Amop-Core'!
SystemOrganization addCategory: #'Amop-Core-Tests'!
SystemOrganization addCategory: #'Amop-Compiler'!

TestCase subclass: #TestReadOnlyChaining
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 13:58'!
instantiateAndSetUp: class 
	| o  proxyAndHandler |
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o .
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	proxyAndHandler := Proxy proxy: o handlerClass: ReadOnlyChainingHandler. 
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 12:21'!
testCompuation
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	res := proxy trap: [ :o | o computeSum ] arguments: #() .
	self assert: ( res  baseObject  = 42 )  .! !

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 09:34'!
testMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	self should:	[ res := proxy trap: [ :o | o memoizeSum ] arguments: #() . ] raise: ReadOnlyError .! !

!TestReadOnlyChaining methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 12:21'!
testMock
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	res := proxy trap: [ :o | o mockSum ] arguments: #() .
	self assert: ( res  baseObject  = 42 )  .! !

TestCase subclass: #TestReadOnlyReplacing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestReadOnlyReplacing methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:00'!
instantiateAndSetUp: class 
	| o  proxyAndHandler |
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o .
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	proxyAndHandler := Proxy proxy: o handlerClass: ReadOnlyReplacingHandler. 
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestReadOnlyReplacing methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:02'!
testCompuation
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	res := proxy trap: [ :o | o computeSum ] arguments: #() .
	self assert: ( res  target  = 42 )  .! !

!TestReadOnlyReplacing methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:01'!
testMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	self should:	[ res := proxy trap: [ :o | o memoizeSum ] arguments: #() . ] raise: ReadOnlyError .! !

!TestReadOnlyReplacing methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:02'!
testMock
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	res := proxy trap: [ :o | o mockSum ] arguments: #() .
	self assert: ( res  target  = 42 )  .! !

TestCase subclass: #TestTransparency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 09:23'!
instantiateAndSetUp: class 
	| o proxyAndHandler |
	o := class basicNew.
	proxyAndHandler := Proxy proxyAndHandler: o. 
	ProxyHandler receiverProxy: (proxyAndHandler at: 1)  handler: (proxyAndHandler at: 2).
	o initialize.
	Transcript show: '-----------------';cr.
	^ (proxyAndHandler at: 1). ! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:42'!
testCompuation
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	res := proxy trap: [ :o | o computeSum ] arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o memoizeSum ] arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o mockSum ] arguments: #() .
	self assert: ( res  handler target = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 09:23'!
testMemoize
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	res := proxy trap: [ :o | o memoizeSum ] arguments: #() .
	self assert: ( res  handler target  = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 09:23'!
testMock
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject..
	res := proxy trap: [ :o | o mockSum ] arguments: #() .
	self assert: ( res  handler target = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 14:58'!
testReturn42
 	| proxy res  |
	proxy := self instantiateAndSetUp: TestObject.
	res := proxy trap: [ :o | o return42 ] arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o selfReturn42 ] arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	proxy := self instantiateAndSetUp: SubTestObject.
	res := proxy trap: [ :o | o return42 ] arguments: #() .
	self assert: ( res  handler target  = 42 )  .
	res := proxy trap: [ :o | o selfReturn42 ] arguments: #() .
	self assert: ( res  handler target  = 42 )  .! !

!TestTransparency methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 14:58'!
testReturnObject
	| proxy res |
	proxy := self instantiateAndSetUp: TestObject.
	res := proxy trap: [ :o | o returnObject ] arguments: #() .
	self assert: ( res  handler target  = nil ) not   .
	res := proxy trap: [ :o | o selfReturnObject ] arguments: #() .
	self assert: ( res  handler target  = nil ) not  .
	proxy := self instantiateAndSetUp: SubTestObject.
	res := proxy trap: [ :o | o returnObject ] arguments: #() .
	self assert: ( res  handler target  = nil ) not   .
	res := proxy trap: [ :o | o selfReturnObject ] arguments: #() .! !

RBBlockNode subclass: #RBAmopBlockNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!RBAmopBlockNode methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:39'!
isAmopBlockNode
	^true! !

!RBBlockNode methodsFor: '*amop' stamp: 'ewe 9/4/2012 14:52'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ] ) or: 
	[  (self parent isMessage and: [ self parent selector = #trap:arguments:  ] ) ] )  not . 
	! !

!RBMessageNode methodsFor: '*amop' stamp: 'ewe 8/30/2012 10:51'!
isNew
	^ self selector = #new! !

!RBArrayNode methodsFor: '*amop' stamp: 'ewe 9/4/2012 14:15'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self parent isMessage and: [ self parent selector = #literalTrap: ] ) or: 
	[  (self parent isMessage and: [ self parent selector = #trap:arguments:  ] ) ] )  not . 
	! !

RBProgramNodeVisitor subclass: #AmopVisitor
	instanceVariableNames: 'currentClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 14:12'!
acceptArrayNode: anArrayNode 
	| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
	
	anArrayNode children do: [:each | self visitNode: each].
	
	(anArrayNode needsAmopRewrite) ifTrue: [
	
		myself := self buildVariableNode: 'self'. 
				
		proxyMessageNode := RBMessageNode receiver:  myself
	 		selector: #receiverProxy
				arguments: { }. 
		
		orignalMessageNode := RBMessageNode receiver: proxyMessageNode
			selector: #literalTrap:
			arguments: {  	RBArrayNode statements: anArrayNode statements .	 }.
		
		anArrayNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:50'!
acceptAssignmentNode: anAssignmentNode 
	| myself  field proxyMessageNode trapMessageNode |
	Transcript show: 'Assignemt'.
	
	"self visitNode: anAssignmentNode variable."
	self visitNode: anAssignmentNode value.
	
	myself := self buildVariableNode: 'self'. 
	field := self buildLiteralNode: anAssignmentNode variable name. 
	
	proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
		
	trapMessageNode := RBMessageNode receiver:  proxyMessageNode
		 	selector: #writeField:value: 
			arguments: { field .  anAssignmentNode value }.
			
	anAssignmentNode replaceWith: trapMessageNode.		
		! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 14:56'!
acceptBlockNode: aBlockNode 
	| myself proxyMessageNode orignalMessageNode |

	(aBlockNode needsAmopRewrite) ifTrue: [
	
		myself := self buildVariableNode: 'self'. 
				
		proxyMessageNode := RBMessageNode receiver:  myself
	 		selector: #receiverProxy
				arguments: { }. 
		
		orignalMessageNode := RBMessageNode receiver: proxyMessageNode
			selector: #literalTrap:
			arguments: {  	RBBlockNode arguments: aBlockNode arguments body: aBlockNode body }.
		
		aBlockNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 14:08'!
acceptLiteralArrayNode: aRBLiteralArrayNode 
	
	| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
	
	aRBLiteralArrayNode contents do: [:each | self visitNode: each].
	
	(aRBLiteralArrayNode needsAmopRewrite) ifTrue: [
	
		myself := self buildVariableNode: 'self'. 
				
		proxyMessageNode := RBMessageNode receiver:  myself
	 		selector: #receiverProxy
				arguments: { }. 
		
		orignalMessageNode := RBMessageNode receiver: proxyMessageNode
			selector: #literalTrap:
			arguments: {  	RBLiteralArrayNode value: aRBLiteralArrayNode value .	 }.
		
		aRBLiteralArrayNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 11:46'!
acceptLiteralNode: aLiteralNode

	(aLiteralNode needsAmopRewrite) ifTrue: [
		| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
			
		myself := self buildVariableNode: 'self'. 
				
		proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy
			arguments: { }. 
			
		orignalMessageNode := RBMessageNode receiver: proxyMessageNode
			selector: #literalTrap: 
			arguments: { 
				self buildLiteralNode: aLiteralNode value 
			 }.
		
		aLiteralNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	]! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 14:27'!
acceptMessageNode: messageNode 

	( messageNode isNew ) ifTrue: [
		^ self acceptNewMessageNode: messageNode  
	].

	( messageNode isSelfSend ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^self acceptSelfMessageNode: messageNode.
	].
	
	( messageNode isSuperSend ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^super acceptMessageNode:  messageNode.
	].

	^self acceptNormalMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 12:06'!
acceptNewMessageNode: messageNode 

	(messageNode needsAmopRewrite) ifTrue: [
		| myself selector sender arguments proxyMessageNode chainMessageNode orignalMessageNode |
			
		myself := self buildVariableNode: 'self'. 
		selector := self buildLiteralNode: messageNode selector. 
		arguments := RBArrayNode statements: messageNode arguments.
				
		proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy
			arguments: { }. 
			
		orignalMessageNode := RBMessageNode receiver: proxyMessageNode
			selector: #newTrap:
			arguments: { 
				RBMessageNode receiver:  messageNode receiver
		 		selector: #new
				arguments: { } .
			 }.
		
		messageNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 14:29'!
acceptNormalMessageNode: messageNode 

	
	(messageNode receiver isLiteral and: [ messageNode receiver name first isUppercase] ) ifTrue: [
		^ super acceptMessageNode: messageNode.
	].

	(messageNode needsAmopRewrite) ifTrue: [
		| myself block selector sender arguments proxyMessageNode orignalMessageNode |
		Transcript show: 'Rewrite '; show: messageNode selector; cr. 
		block := self buildSyntheticBlock: messageNode.
		arguments := RBArrayNode statements: messageNode arguments.
		
		orignalMessageNode := RBMessageNode receiver:  messageNode receiver 
		 	selector: #trap:arguments:
			arguments: { block . arguments  }.
		
		messageNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 17:20'!
acceptSelfMessageNode: messageNode 

	(messageNode needsAmopRewrite) ifTrue: [
		| myself block selector sender arguments proxyMessageNode orignalMessageNode |
			
		myself := self buildVariableNode: 'self'. 
		selector := self buildLiteralNode: messageNode selector. 
		block := self buildSyntheticBlock: messageNode.
		arguments := RBArrayNode statements: messageNode arguments.
		
		proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
		
		orignalMessageNode := RBMessageNode receiver:  proxyMessageNode
		 	selector: #trap:arguments:
			arguments: { block . arguments  }.
		
		messageNode replaceWith: orignalMessageNode.		
		^ super visitNode: orignalMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:50'!
acceptVariableNode: aVariableNode

	| myself  field proxyMessageNode trapMessageNode |
	
	( currentClass instVarNames includes: aVariableNode name ) ifTrue: [
		Transcript show: 'Variable'.
		myself := self buildVariableNode: 'self'. 
		field := self buildLiteralNode: aVariableNode name. 
		
		proxyMessageNode := RBMessageNode receiver:  myself
		 	selector: #receiverProxy 
			arguments: {}.
			
		trapMessageNode := RBMessageNode receiver:  proxyMessageNode
		 	selector: #readField:
			arguments: { field }.
			
		 aVariableNode  replaceWith: trapMessageNode.	
	].	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:43'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:29'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBAmopBlockNode 
			arguments: blockArguments
			body: blockBody. 
			
		^ block
		! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:44'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:30'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

!AmopVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:26'!
visitNode: aNode class: class
	currentClass := class. 
	^self visitNode: aNode. ! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor3
	instanceVariableNames: 'skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/22/2012 14:00'!
acceptArrayNode: arrayNode 
	| newArrayNode newMessageNode |

	"Exclude certain nodes (see acceptMethodNode)"
	skip ifTrue: [ ^ super acceptArrayNode: arrayNode. ].
	
	(arrayNode isOwnershipArrayNode) ifFalse: [
	
		newArrayNode:= RBOwnershipArrayNode statements: arrayNode statements.
	
		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).
	
		arrayNode replaceWith: newMessageNode.	
		
		^ super visitNode: newMessageNode.
	
	].
	
	^ super acceptArrayNode: arrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/22/2012 13:59'!
acceptLiteralArrayNode: literalArrayNode 
	| newArrayNode newMessageNode |

	"Exclude certain nodes (see acceptMethodNode)"
	skip ifTrue: [ ^ super acceptLiteralArrayNode: literalArrayNode. ].
	
	(literalArrayNode isOwnershipLiteralArrayNode) ifFalse: [

		newArrayNode:= RBOwnershipArrayNode statements: literalArrayNode contents.

		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).

		literalArrayNode replaceWith: newMessageNode.
		
		^ super visitNode: newMessageNode.
	
	].
	^ super acceptLiteralArrayNode: literalArrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/27/2012 14:47'!
acceptMessageNode: messageNode 
	| logging |
	"logging = true: self and super will be converted to  self track: [ original method ] selector: #selector"
	logging:= false.
	
	"Excluse certain methods (see acceptMethodNode)"
	skip ifTrue: [ ^super acceptMessageNode: messageNode. ].

	( logging and: [ messageNode isSelfSend or: [messageNode isSuperSend ] ] ) ifTrue: [  
		 "if logging, special transformation for self and super sends"
		^self acceptSelfAndSuperMessageNode: messageNode.
	]
	ifFalse: [
		"normal case"
		^self acceptNormalMessageNode: messageNode.
	].! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 7/10/2012 17:05'!
acceptMethodNode: aMethod
	VariableNameCounter resetCounter. 
	skip := aMethod isOwernshipMeta.
	^ super acceptMethodNode: aMethod.
	! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 6/28/2012 09:14'!
acceptNormalMessageNode: messageNode 

	"Exclude self and super sends and few other cases"
	(messageNode isExcluded ) 
		ifTrue: [ ^super acceptMessageNode: messageNode. ].	
		
				
	(messageNode needsOwnershipRewrite) ifTrue: [
		| block selector sender arguments newMessageNode |
			
		"block := self buildVariableNode: 'self'. "
		block := self buildSyntheticBlock: messageNode .
		selector := self buildLiteralNode: messageNode selector. 
		sender := self buildVariableNode: 'self'.
		arguments := RBOwnershipArrayNode statements: messageNode arguments.
				
		newMessageNode:= RBMessageNode receiver:  messageNode receiver
		 	selector: #checkValidSend3:message:block:arguments:
			arguments: { sender. selector. block. arguments}.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].

	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 6/26/2012 16:10'!
acceptSelfAndSuperMessageNode: messageNode 

"Send type logger, special block for this case:"
	
	"Exclude self thisSender"
	(messageNode isSelfSend and: [messageNode selector = #thisSender]) ifTrue: [
		 ^super acceptMessageNode: messageNode.
		].
	
	 ((messageNode isSelfSend or: [ messageNode isSuperSend ])  and: [messageNode needsOwnershipRewrite ])
		ifTrue: [ 
			| block selector arguments newMessageNode receiver |
			
			block:= self buildTrackBlock: messageNode .
			selector := self buildLiteralNode: messageNode selector. 
				
			newMessageNode:= RBMessageNode receiver:  (self buildVariableNode: 'self')
		 	selector: #track:selector:
			arguments: { block. selector.}.
		
			messageNode replaceWith: newMessageNode.
			
			^ super visitNode: newMessageNode.
			
			
			].
	"------------------------------------------"
	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:58'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:33'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBOwnershipBlockNode 
			arguments: blockArguments
			body: blockBody. 
			
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 6/26/2012 12:09'!
buildTrackBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiver := messageNode receiver.
		blockBodyMessageArguments:= messageNode arguments.

		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		block := RBOwnershipBlockNode
			body: blockBody. 
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:30'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:29'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

!RBLiteralNode methodsFor: '*amop' stamp: 'ewe 9/4/2012 11:47'!
needsAmopRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ (self parent isMessage and: [ self parent selector = #literalTrap: ])   not . 
	! !

RBCompiler subclass: #AmopCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!AmopCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:26'!
translate: aProgramNode
AmopVisitor new visitNode: aProgramNode methodNode class: class ..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

!OwnershipCompiler3 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:20'!
translate: aProgramNode
OwnershipCompilerMessageVisitor3 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

Object subclass: #BaseObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!BaseObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 14:16'!
receiverProxy 
	"TODO walk up the chain until the LAST proxy, consider chains of proxy and super sends"
	"self receiverProxy returns the caller of the current activation"
	^ ProxyHandler receiverProxy.! !

!BaseObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 11:47'!
test
	^ self xxx     ! !

BaseObject subclass: #Helper
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!Helper class methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 14:15'!
compilerClass 
	^AmopCompiler! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 11:47'!
compute: v1 sum: v2 
	Transcript show: 'compute:sum:' ; cr.
	^v1+v2 ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:52'!
memoize: v1 sum: v2
	( key = { v1 . v2 } ) ifFalse: [  
		key := { v1 . v2 }.   
		value := v1 + v2  
	]. 
	^ value.   ! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 12:05'!
mock: v1 sum: v2
	^42! !

!Helper methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 12:11'!
reset
	key := nil.
	value:= nil. ! !

BaseObject subclass: #TestObject
	instanceVariableNames: 'helper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

TestObject subclass: #SubTestObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!SubTestObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 12:02'!
return42
	^super return42.! !

!SubTestObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:48'!
returnObject 
	^super returnObject.! !

!SubTestObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:47'!
selfReturn42
	^ super selfReturn42 ! !

!SubTestObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:48'!
selfReturnObject
	^ super selfReturnObject! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 12:02'!
compilerClass 
	^AmopCompiler! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 12:16'!
newp
	^ Proxy for: self new. ! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 11:51'!
computeSum
	Transcript show: 'computeSum' ; cr. 
 	^ helper compute: 21 sum: 21 .  ! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 12:11'!
initialize 
	helper := Helper new.. 
	helper reset.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 12:12'!
memoizeSum
 	^ helper memoize: 20 sum: 22 . ! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 12:12'!
mockSum 
 	^ helper mock: 0 sum: 0 . ! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/28/2012 12:01'!
return42
	^ 42! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 12:04'!
returnObject
	^ Object new. ! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 9/3/2012 16:52'!
selfReturn42
	^ self return42! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 10:47'!
selfReturnObject
	^ self returnObject  ! !

!Object methodsFor: '*amop' stamp: 'ewe 9/5/2012 10:36'!
isAmopProxy
	^false! !

Object subclass: #OwnedObject3
	uses: TOwnershipCheck
	instanceVariableNames: 'dynamicOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Compiler'!

OwnedObject3 class
	uses: TOwnershipCheck classTrait
	instanceVariableNames: ''!

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 5/2/2012 16:45'!
borrow: anObject do: aBlock
	| oldOwner |
	oldOwner := anObject owner. 
	anObject owner: self. 
	[
	  ^aBlock value: anObject. 
	] ensure: [
		anObject owner: oldOwner. 
	]! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/20/2012 11:20'!
canNotSend: selector to: receiver
	[ self canSend: selector to: receiver ] on: MessageFiltered do: [ ^ true ]. 
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/19/2012 16:10'!
canSend: selector to: receiver
	"Tests whether the object can send the message to the receiver"
	self checkValidSend3: receiver message: selector block: [:t | ^ true] arguments: {}.
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 6/25/2012 15:01'!
copy
	<meta>
	| copy |
	copy := super copy. 
	copy ownerNoCheck: self owner. 
	^ copy. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 7/5/2012 15:32'!
isAccessibleFrom: aSource
	| interfaces |
	interfaces := self class allPragmas .
	self handleFilters: aSource selector: #any interfaces: interfaces. 
	
! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 7/5/2012 15:52'!
isAccessibleFromAllReferencs

	"This check is too slow in practice"
	true ifTrue: [ ^self ].
	
	self pointersTo do: [ :source | 
		( source isKindOf: OwnedObject3 ) ifTrue: [
			"Transcript show: 'Check from' ; show: source class asString ; cr.  "	
			self isAccessibleFrom: source ]
	]! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'ewe 6/27/2012 17:26'!
owner
	dynamicOwner isNil ifTrue: [ dynamicOwner := WorldOwner getInstance ].
	^ dynamicOwner. ! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 7/5/2012 15:30'!
owner: newOwner
	"Transcript show:  'Attempt to transfer ownership (object: ' ; show: self class printString ;
	show: ', candidate owner: ' ; show:  newOwner class printString ; show:  ')' ; cr ."
	(newOwner acceptOwnershipOf: self ) ifTrue: [
		WorldOwner resetPathCache.
		dynamicOwner := newOwner. 
		"Transcript show:  'Ownership transfer succeeded' ; cr ."
		self isAccessibleFromAllReferencs.
		
	] ifFalse: [ 
		Transcript show: thisContext traceString  ; cr. 
		TransferError signal
	 ].
	"TODO the method does not return itself, as this might create violations"
	 ^nil. ! !

!OwnedObject3 methodsFor: 'enforcement' stamp: 'pmaer 7/4/2012 15:20'!
ownerNoCheck: newOwner
	"TODO this one should ideally never be used. Momentary necessary because of instrumented / not instrumente d code"
	"setter for owner"
	WorldOwner resetPathCache.
	dynamicOwner := newOwner.! !

Object subclass: #Proxy
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:38'!
for: aTarget
	^ self for: aTarget handlerClass: ProxyHandler ! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:27'!
for: aTarget handlerClass: handlerClass
	| proxAndHandler |
	proxAndHandler := self proxy: aTarget handlerClass: handlerClass. 
	^ proxAndHandler at: 1. ! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:47'!
handler: aHandler
	^ self new handler: aHandler ; yourself.! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:26'!
proxy: aTarget handlerClass: handlerClass
	| proxy handler |
	handler := handlerClass target: aTarget. 
	proxy := self handler: handler. 
	"ProxyTrap adoptInstance:  proxy. "
	^ { proxy . handler }. ! !

!Proxy class methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:27'!
proxyAndHandler: aTarget
	^ self proxy: aTarget handlerClass: ProxyHandler. ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:52'!
baseObject 
	| target |
	target  := handler target .
	target isAmopProxy ifTrue: [ 
		^ target baseObject. .
	].
	^ target. ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:28'!
chainFrom: previousHandler trap: block arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message selector |
		
	target := handler target.  
	selector := #xxx. 
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>chainTrap ' ; show: selector ; show: '@'; show: target class asString ; cr.
	
	"We do not rebind self"
	senderHandler := previousHandler.
	receiverHandler := handler.
	
	message := Message selector: selector  arguments: arguments .
	
	"Invoke 
	(1) param out on the sender, (2) param in on the receiver, 
	(3) delegate processing of the message
	(4) return out on the receiver, (5) return in on the sender "
		
	target isAmopProxy ifTrue: [
		^ senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |
			receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
				target chainFrom: receiverHandler trap: block arguments: argsIn ]] .
	] ifFalse: [
		^ senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |
			receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
				| targetWithArgs |
				targetWithArgs := OrderedCollection new.
				targetWithArgs add: target. 
				targetWithArgs addAll: argsIn. 
				block valueWithArguments: targetWithArgs ] ] .
	]
	

	! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 11:44'!
handler
 ^handler! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:45'!
handler: aHandler
	handler := aHandler. ! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 10:36'!
isAmopProxy 
	^true! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:20'!
literalTrap: argument
	|  target  |
	target := handler target. .
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>literalTrap ' ; show: '@'; show: target class asString ; cr.
	target isAmopProxy ifTrue: [
		^ handler literalTrapContinue: [ target literalTrap: argument ].
	] ifFalse: [
		^ handler literalTrapContinue: [ argument ].
	]! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:20'!
newTrap: argument
	|  target  |
	target := handler target.
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>newTrap ' ; show: '@'; show: target class asString ; cr.
	target isAmopProxy ifTrue: [
		^ handler newTrapContinue: [ target newTrapContinue: argument ].
	] ifFalse: [
		^ handler newTrapContinue: [ argument ].
	]
	
	! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:20'!
readField: field 
	|  target  |
	target := handler target.  
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>readField ' ; show: field ; show: '@'; show: target class asString ; cr.
	target isAmopProxy ifTrue: [
		^ handler readField: field 
				continue: [ target readField: field ]
	] ifFalse: [
		^ handler readField: field 
				continue: [ target instVarNamed: field ]
	]
	
	! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 10:37'!
target
	^handler target! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 11:27'!
trap: block arguments: arguments
	
	| sender receiver senderHandler receiverHandler target message selector |
		
	target := handler target.  
	selector := #xxx. 
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>trap ' ; show: selector ; show: '@'; show: target class asString ; cr.
	
	"sender of this message is the old receiver"
	sender := ProxyHandler receiverProxy. 
	senderHandler := ProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := handler.
	ProxyHandler receiverProxy:  receiver handler: receiverHandler.. 
	
	message := Message selector: selector  arguments: arguments .
	
	"Invoke 
	(1) param out on the sender, (2) param in on the receiver, 
	(3) delegate processing of the message
	(4) return out on the receiver, (5) return in on the sender "
		
	target isAmopProxy ifTrue: [
		^ senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |
			receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
				target chainFrom: receiverHandler  trap: block arguments: argsIn ]] .
	] ifFalse: [
		^ senderHandler messageOut: message receiver: receiverHandler continue: [ :argsOut |
			receiverHandler messageIn: message sender: senderHandler continue: [ :argsIn |
				| targetWithArgs |
				targetWithArgs := OrderedCollection new.
				targetWithArgs add: target. 
				targetWithArgs addAll: argsIn. 
				block valueWithArguments: targetWithArgs ] ] .
	]
	

	! !

!Proxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 13:56'!
writeField: field value: value
	|  target  |
	target := handler target.  
	Transcript show: 'Proxy[' ; show:  self handler class asString ; show: ']>>writeField ' ; show: field ;show: '@';  show: target class asString ; cr.
	target isAmopProxy ifTrue: [
		^ handler writeField: field
				value: value  
				continue: [ :val |  target writeField: field value: val ]
	] ifFalse: [
		^ handler writeField: field 
			 value: value
				continue: [ :val | target instVarNamed: field 
							      put: val ]
	]! !

Proxy subclass: #ValueProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:41'!
literalTrap: argument
		argument inspect. . self error: 'Not for value: literalTrap'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:40'!
newTrap: argument
	self error: 'Not for value: newTrap'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:40'!
readField: field 
	self error: 'Not for value: readField'.! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 12:23'!
trap: block arguments: arguments
	
	| targetWithArgs target selector |		
	target := handler target.  
	Transcript show: 'ValueProxy[' ; show:  self handler class asString ; show: ']>>trap ' ; show: selector ; show: '@'; show: target class asString ; cr.	
		
	target isAmopProxy ifTrue: [
		targetWithArgs := OrderedCollection new.
		targetWithArgs addAll: arguments. 
	 	^ target trap: block arguments: targetWithArgs .
	] ifFalse: [
		targetWithArgs := OrderedCollection new.
		targetWithArgs add: target. 
		targetWithArgs addAll: (arguments collect: [ :item | item baseObject ]). 
		^super literalTrap: ( block valueWithArguments: targetWithArgs ) .
	].
		
	! !

!ValueProxy methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 15:41'!
writeField: field value: value
	self error: 'Not for value: writeField.' . ! !

Object subclass: #ProxyHandler
	instanceVariableNames: 'target'
	classVariableNames: 'Receiver ReceiverHandler'
	poolDictionaries: ''
	category: 'Amop-Core'!

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 14:16'!
receiverProxy
	^Receiver ! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/30/2012 17:22'!
receiverProxy: anObject 
	^ Receiver := anObject.! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:21'!
receiverProxy: anObject handler: aHandler
	 Receiver := anObject.
	  ReceiverHandler:=aHandler.! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:20'!
receiverProxyHandler
	^ReceiverHandler! !

!ProxyHandler class methodsFor: 'as yet unclassified' stamp: 'ewe 8/31/2012 11:47'!
target: aTarget
	^ self new target: aTarget ; yourself. ! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/4/2012 15:17'!
literalTrapContinue: proceed 
	^ ValueProxy for: proceed value.! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:05'!
messageIn: aMessage sender: senderHandler continue: proceed
	^ proceed value: aMessage arguments.! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:05'!
messageOut: aMessage receiver: receiverHandler continue: proceed
	^ proceed value: aMessage arguments. ! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/4/2012 15:17'!
newTrapContinue: proceed 
	^ Proxy for:  proceed value.! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 16:24'!
readField: aField  continue: proceed
	^ proceed value.! !

!ProxyHandler methodsFor: 'accessor' stamp: 'ewe 8/31/2012 11:47'!
target
	^ target.! !

!ProxyHandler methodsFor: 'accessor' stamp: 'ewe 8/31/2012 11:47'!
target: aTarget
	target := aTarget.! !

!ProxyHandler methodsFor: 'trap' stamp: 'ewe 9/3/2012 15:06'!
writeField: aField value: aValue continue: proceed
	^ proceed value: aValue.! !

ProxyHandler subclass: #ReadOnlyChainingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:04'!
literalTrapContinue: proceed 
	"Will wrap the proceed in a ValueProxy"
		^ ValueProxy for: proceed value ! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 13:58'!
newTrapContinue: proceed 
	^ Proxy for:  proceed value handlerClass: ReadOnlyChainingHandler ..! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 13:58'!
readField: aField  continue: proceed
	| roproxy proxy |
	proxy := proceed value.  
	Transcript show: 'Read '; show: aField ; show: ' '; show: proxy class asString ; cr.
	( proxy isKindOf: ValueProxy ) ifFalse: [
		Transcript show: 'Convert to read only'; cr.
		^  Proxy for: proxy  handlerClass: ReadOnlyChainingHandler .
	].
	Transcript show: 'Return original' ; cr. 
	^proxy! !

!ReadOnlyChainingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 09:33'!
writeField: aField value: aValue continue: proceed
	ReadOnlyError signal:  'Read only handler can not write'. ! !

ProxyHandler subclass: #ReadOnlyReplacingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!

!ReadOnlyReplacingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:05'!
literalTrapContinue: proceed 
	"Will wrap the proceed in a ValueProxy"
	^ ValueProxy for: proceed value ! !

!ReadOnlyReplacingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:02'!
newTrapContinue: proceed 
	^ Proxy for:  proceed value baseObject handlerClass: ReadOnlyReplacingHandler.! !

!ReadOnlyReplacingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 14:02'!
readField: aField  continue: proceed
	| roproxy proxy |
	proxy := proceed value.  
	Transcript show: 'Read '; show: aField ; show: ' '; show: proxy class asString ; cr.
	( proxy isKindOf: ValueProxy ) ifFalse: [
		Transcript show: 'Convert to read only'; cr.
		^  Proxy for: proxy baseObject  handlerClass: ReadOnlyReplacingHandler  .
	].
	Transcript show: 'Return original' ; cr. 
	^proxy! !

!ReadOnlyReplacingHandler methodsFor: 'as yet unclassified' stamp: 'ewe 9/5/2012 13:58'!
writeField: aField value: aValue continue: proceed
	ReadOnlyError signal:  'Read only handler can not write'. ! !

Object subclass: #ProxyOld
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!ProxyOld methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 09:49'!
cannotInterpret: aMessage
	| sender receiver senderHandler receiverHandler target |
	
	Transcript show: aMessage selector asString ; cr.
	
	target := handler target.  
	
	"sender of this message is the old receiver"
	sender := ProxyHandler receiverProxy. 
	senderHandler := ProxyHandler receiverProxyHandler.
	"now swap the receiver"
	receiver := self.
	receiverHandler := handler.
	ProxyHandler receiverProxy:  receiver handler: receiverHandler.. 
	
	( aMessage selector = #newTrap: ) ifTrue: [
		^ handler newTrapContinue: [ Proxy for: aMessage arguments first ].
	].
	( aMessage selector = #readField: ) ifTrue: [
		^ handler readField: aMessage arguments first 
				continue: [ target instVarNamed: aMessage arguments first ]
	].
	( aMessage selector = #writeField:value: ) ifTrue: [
		^ handler writeField: aMessage arguments first 
				value: aMessage arguments second
				continue: [ :val | target instVarNamed: aMessage arguments first 
							      put: val ]
	].

	"Invoke 
	(1) param out on the sender, (2) param in on the receiver, 
	(3) delegate processing of the message
	(4) return out on the receiver, (5) return in on the sender "

	^ senderHandler messageOut: aMessage receiver: receiverHandler continue: [ :argsOut |
		receiverHandler messageIn: aMessage sender: senderHandler continue: [ :argsIn |
			target perform: aMessage selector withArguments: argsIn  ] ].! !

!ProxyOld methodsFor: 'as yet unclassified' stamp: 'ewe 9/4/2012 09:50'!
handler: aHandler
	handler := aHandler. ! !

ProxyOld subclass: #ProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core'!

!ProxyTrap class methodsFor: 'as yet unclassified' stamp: 'ewe 8/24/2012 16:04'!
initialize 
	methodDict := nil. ! !

Error subclass: #ReadOnlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amop-Core-Tests'!
ProxyTrap initialize!
